
-- # import Nat

-- Lists

data List (a : Set) : Set where
  nil  : List a
  (::) : a -> List a -> List a

infixr 10 ::

length (a : Set) : List a -> Nat
length []      = 0
length (x :: xs) = 1 + length xs

map (a,b : Set) : (a -> b) -> List a -> List b
map f [] = []
map f (x :: xs) = f x :: map f xs

scanl (a,b : Set) : (a -> b -> a) -> a -> List b -> List a
scanl f z [] = [z]
scanl f z (x :: xs) = z :: scanl f (f z x) xs

scanl1 (a : Set) : (a -> a -> a) -> List a -> List a
scanl1 f []	 = []
scanl1 f (x :: xs) = scanl f x xs

