{- | Identifiers recognized by the FOL plugin. -}

module Plugins.FOL.Constants where

-- FOL constant names -----------------------------------------------------

fol_Prop    :: String
fol_And	    :: String 
fol_Or	    :: String
fol_Implies :: String
fol_Equiv   :: String
fol_Not	    :: String
fol_Equals  :: String
fol_ForAll  :: String
fol_Exists  :: String

--fol_Holds   = "Holds"
fol_Prop    = "Prop"
fol_And	    = "/\\"
fol_Or	    = "\\/"
fol_Implies = "==>"
fol_Equiv   = "<=>"
fol_Not	    = "Not"
fol_Equals  = "Eq"
fol_True    = "True"
fol_False   = "False"
fol_ForAll  = "ForAll"
fol_Exists  = "Exists"

folConstants = [  fol_And, fol_Or, fol_Implies, fol_Equiv
		, fol_Not, fol_Equals, fol_ForAll, fol_Exists
		, fol_Prop, fol_True, fol_False
		]

isFOLConstant :: String -> Bool
isFOLConstant x = x `elem` folConstants	

