
module TypeChecker.Values.DeBruijn where

import Control.Monad.Trans

import Syntax.Internal
import Syntax.Values
import TypeChecker.Monad
import TypeChecker.Monad.Context
import TypeChecker.Context
import TypeChecker.Abstractions
import Utils.Monads

{------------------------------------------------------------------------
    Replacing deBruijn indices with names
 ------------------------------------------------------------------------}

unBruijn :: Instantiate a => a -> TC a
unBruijn v = instantiate v . mkInst <$> getContext
    where
	mkInst gamma = [ vId x | (x, Abstract _) <- gamma ]

