-- Lattice theory

-- # import Property

D : Set
(≤) : D -> D -> Prop
(⊓) : D -> D -> D
(⇐⇒) = (<=>)
(∧) = (/\)

infix 5 ≤
infixl 6 ⊓
infixl 3 ∧
infix 2 ⇐⇒

ax1 : (x : D) ->  (x ≤ x)
ax2 : (x : D) -> (y : D) -> (z : D) ->
	 ( z ≤ x ⊓ y	⇐⇒
	   z ≤ x ∧ z ≤ y
	 )

test : (p : Prop) -> (x : D) ->  (x ≤ x ⊓ x ⇐⇒ p)

-- this property should fail:
p : (x : D) -> (y : D) ->  (x ≤ x ⊓ y)
p = fol-plugin (ax1, ax2)

p' : (x : D) -> (y : D) ->  (x ⊓ y ≤ x)
p' = \x -> \y -> fol-plugin (ax1, ax2)

