
data List (A : Set) : Set where
  nil : List A
  (::) : A -> List A -> List A

infixr 6 ::

cat : (A : Set) -> List A -> List A -> List A
cat A nil ys	   = ys
cat A (x :: xs) ys = x :: cat A xs ys

reverse : (A : Set) -> List A -> List A
reverse A nil	    = nil
reverse A (x :: xs) = cat A (reverse A xs) (x :: nil)

foldr : (A,B : Set) -> (A -> B -> B) -> B -> List A -> B
foldr A B f z nil	= z
foldr A B f z (x :: xs) = f x (foldr A B f z xs)

X : Set
x : X
y : X
z : X

test = reverse X (x :: y :: z :: nil)

