
data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

data List (A : Set) : Set where
  nil : List A
  (::) : A -> List A -> List A

reverse (A : Set) : List A -> List A
reverse {A} xs = rev xs []
  where
    rev : List A -> List A -> List A
    rev [] ys	    = ys
    rev (x :: zs) ys  = rev zs (x :: ys)
